//+------------------------------------------------------------------+
//|                                                 correlations.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    8
#property indicator_level1     0
#property indicator_levelcolor DimGray

//
//
//
//
//

#import "correlations.dll"
   double Pearson(double& arrayA[], int isSeriesA, double& arrayB[], int isSeriesB, int bars, int shift, int length,int returnValue);
   double Kendall(double& arrayA[], int isSeriesA, double& arrayB[], int isSeriesB, int bars, int shift, int length,int returnValue);
   double Spearman(double& arrayA[], int isSeriesA, double& arrayB[], int isSeriesB, int bars, int shift, int length,int returnValue);
#import

//
//
//
//
//

extern string             _           = "parameters";
extern string             Symbols     = "EURJPY;EURUSD;EURCHF;GBPJPY;GBPUSD;USDJPY;USDCAD;USDCHF";
extern int                Length      = 50;
extern ENUM_APPLIED_PRICE Price       = PRICE_CLOSE;
extern double             SmoothLength = 1;
extern double             SmoothPhase  = 0;
extern int                Type        = 0;
extern int                SubType     = 0;
extern color              colorFrom   = LimeGreen;
extern color              colorMiddle = Gold;
extern color              colorTo     = MediumVioletRed;
extern int                linesWidth  = 0;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
string aPairs[];
string sPairs[];

double prices0[];
double prices1[];
double prices2[];
double prices3[];
double prices4[];
double prices5[];
double prices6[];
double prices7[];
double prices8[];

//
//
//
//
//

int    totalSymbols;
string IndicatorFileName;
bool   gettingBars = false;
string prefix      = "NA";
string suffix      = "NA";
string shortName;
string labelName;
string indName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
      if (_=="gettingBars")
      {
         gettingBars = true;
         return(0);
      }

      //
      //
      //
      //
      //
      
                                 SetIndexStyle(0,DRAW_LINE,EMPTY,linesWidth,gradientColor(0,4,colorFrom,colorMiddle));
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_LINE,EMPTY,linesWidth,gradientColor(1,4,colorFrom,colorMiddle));
      SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_LINE,EMPTY,linesWidth,gradientColor(2,4,colorFrom,colorMiddle));
      SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_LINE,EMPTY,linesWidth,gradientColor(3,4,colorFrom,colorMiddle));
      SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_LINE,EMPTY,linesWidth,gradientColor(1,5,colorMiddle,colorTo));
      SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_LINE,EMPTY,linesWidth,gradientColor(2,5,colorMiddle,colorTo));
      SetIndexBuffer(6,buffer7); SetIndexStyle(6,DRAW_LINE,EMPTY,linesWidth,gradientColor(3,5,colorMiddle,colorTo));
      SetIndexBuffer(7,buffer8); SetIndexStyle(7,DRAW_LINE,EMPTY,linesWidth,gradientColor(4,5,colorMiddle,colorTo));

      //
      //
      //
      //
      //
      
      string subNameF = "";
      string subNameS = "";
      switch (Type)
      {
         case 0:
            indName = "Pearson ";
               switch (SubType)
               {
                  case 0:                           break;
                  case 1: subNameF = "fisher of ";  break;
                  case 2: subNameS = "Students t "; break;
               }
               break;
         case 1:
            indName = "Kendall\'s tau ";
               switch (SubType)
               {
                  case 0:                           break;
                  case 1: subNameF = "fisher of ";  break;
                  case 2: subNameS = "Students t "; break;
                  case 3: subNameS = "deviations ";  break;
               }
               break;
         case 2:
            indName = "Spearman\'s rank ";
               switch (SubType)
               {
                  case 1: subNameF = "fisher of ";                  break;
                  case 2: subNameS = "Students t ";                 break;
                  case 3: subNameS = "differences ";                break;
                  case 4: subNameS = "expectation of differences "; break;
                  case 5: subNameS = "deviations of differences ";  break;
               }
               break;
      }
      labelName = indName;
      indName   = subNameF+ indName + subNameS;
      
      //
      //
      //
      //
      //
      
   IndicatorFileName = WindowExpertName();
   shortName         = MakeUniqueName(indName," ("+Length+","+SubType+")");
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i=0;i<8;i++) ObjectDelete(shortName+i);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
      
   //
   //
   //
   //
   //

      if (gettingBars) { buffer1[0] = limit; return(0); }
      if (suffix=="NA" || prefix=="NA")
      {
         getSuffixPrefix();
         Symbols = StringUpperCase(StringTrimLeft(StringTrimRight(Symbols)));
         if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                          Symbols = StringConcatenate(Symbols,";");
     
         //
         //
         //
         //
         //

         int  s = 0; i = StringFind(Symbols,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(Symbols,s,i-s);
               if ((prefix+current+suffix)!=Symbol())
               {
                  ArrayResize(aPairs,ArraySize(aPairs)+1);
                              aPairs[ArraySize(aPairs)-1] = current;
               }
               s = i + 1;
               i = StringFind(Symbols,";",s);
            }
         totalSymbols = MathMin(ArraySize(aPairs),8);
      
         //
         //
         //
         //
         //
      
         ArrayResize(sPairs,totalSymbols);
         for (i=0; i<totalSymbols; i++)
         {
            SetIndexLabel(i,labelName+" "+aPairs[i]);
            sPairs[i] = prefix+aPairs[i]+suffix;
         }         
      }      

      //
      //
      //
      //
      //
   
      if (ArrayRange(prices0,0) != Bars)
      {
         ArrayResize(prices0,Bars);
         ArrayResize(prices1,Bars);
         ArrayResize(prices2,Bars);
         ArrayResize(prices3,Bars);
         ArrayResize(prices4,Bars);
         ArrayResize(prices5,Bars);
         ArrayResize(prices6,Bars);
         ArrayResize(prices7,Bars);
         ArrayResize(prices8,Bars);
      }      

      //
      //
      //
      //
      //
         
      int window = WindowFind(shortName);
      for (i=0; i<totalSymbols;i++)
      {
         limit = MathMax(limit,MathMin(Bars-1,iCustom(sPairs[i],0,IndicatorFileName,"gettingBars",0,0)));
         if (ObjectFind(shortName+i) == -1)
         {
               ObjectCreate(shortName+i,OBJ_LABEL,window,0,0);
                  ObjectSet(shortName+i,OBJPROP_XDISTANCE,10);
                  ObjectSet(shortName+i,OBJPROP_YDISTANCE,10+i*14);
                  ObjectSet(shortName+i,OBJPROP_CORNER,1);
                  
                  color theColor;
                  switch(i)
                  {
                     case 0: theColor = gradientColor(0,4,colorFrom,colorMiddle); break;
                     case 1: theColor = gradientColor(1,4,colorFrom,colorMiddle); break;
                     case 2: theColor = gradientColor(2,4,colorFrom,colorMiddle); break;
                     case 3: theColor = gradientColor(3,4,colorFrom,colorMiddle); break;
                     case 4: theColor = gradientColor(1,5,colorMiddle,colorTo);   break;
                     case 5: theColor = gradientColor(2,5,colorMiddle,colorTo);   break;
                     case 6: theColor = gradientColor(3,5,colorMiddle,colorTo);   break;
                     case 7: theColor = gradientColor(4,5,colorMiddle,colorTo);   break;
                  }
                  ObjectSetText(shortName+i,aPairs[i],10,"Courier new bold",theColor);
            }
      }            

   //
   //
   //
   //
   //
            
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      prices0[r] = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i,0);
      if (totalSymbols>0) { prices1[r] = iDSmooth(iMA(sPairs[0],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i, 20); buffer1[i] = getValue(prices1,i); }
      if (totalSymbols>1) { prices2[r] = iDSmooth(iMA(sPairs[1],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i, 40); buffer2[i] = getValue(prices2,i); }
      if (totalSymbols>2) { prices3[r] = iDSmooth(iMA(sPairs[2],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i, 60); buffer3[i] = getValue(prices3,i); }
      if (totalSymbols>3) { prices4[r] = iDSmooth(iMA(sPairs[3],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i, 80); buffer4[i] = getValue(prices4,i); }
      if (totalSymbols>4) { prices5[r] = iDSmooth(iMA(sPairs[4],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i,100); buffer5[i] = getValue(prices5,i); }
      if (totalSymbols>5) { prices6[r] = iDSmooth(iMA(sPairs[5],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i,120); buffer6[i] = getValue(prices6,i); }
      if (totalSymbols>6) { prices7[r] = iDSmooth(iMA(sPairs[6],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i,140); buffer7[i] = getValue(prices7,i); }
      if (totalSymbols>7) { prices8[r] = iDSmooth(iMA(sPairs[7],0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i,160); buffer8[i] = getValue(prices8,i); }
   }                           
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double getValue(double& prices[],int i)
{
   switch(Type)
   {
      case 0: return(Pearson(prices0,false,prices,false,Bars,i,Length,SubType));
      case 1: return(Kendall(prices0,false,prices,false,Bars,i,Length,SubType));
      case 2: return(Spearman(prices0,false,prices,false,Bars,i,Length,SubType));
   }
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//
//
//
//
//
string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      tchar;
   
   while(lenght >= 0)
      {
         tchar = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                  s = StringSetChar(s, lenght, tchar - 32);
          else 
              if(tchar > -33 && tchar < 0)
                  s = StringSetChar(s, lenght, tchar + 224);
         lenght--;
   }
   return(s);
}




//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define sectorSize  1936
#define HFILE_ERROR -1

void getSuffixPrefix()
{ 
   int fileHandle = FileOpenHistory("symbols.raw",FILE_BIN|FILE_READ);
   if (fileHandle == HFILE_ERROR) return;
    
   //
   //
   //
   //
   //

   prefix=""; suffix="";
   for(int i=0;; i++)
   {
      FileSeek(fileHandle, sectorSize*i, SEEK_SET);
      string symbolName = FileReadString(fileHandle,12);
             symbolName = StringSubstr(symbolName, 0);
                   
             //
             //
             //
             //
             //
              
             int pos = StringFind(symbolName,"EURUSD",0);
             if (pos > -1)
             {
                if (pos>0)                         prefix = StringSubstr(symbolName,0,pos);
                if ((pos+6)<StringLen(symbolName)) suffix = StringSubstr(symbolName,(pos+6),0);
                break;
             }     
   } 
   FileClose(fileHandle);
}  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}

double iDSmooth(double price, double length, double phase, int i, int s=0)
{
   return (iSmooth(iSmooth(price,length,phase,i,s),length,phase,i,s+10));
}

//
//
//
//
//

double wrk[][180];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}